## suil 0.8.4~dfsg0

=== wscript ===
#!/usr/bin/env python
import os
import subprocess
import sys
import waflib.Options as Options
import waflib.extras.autowaf as autowaf
from waflib import TaskGen

# Library and package version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
SUIL_VERSION       = '0.8.4'
SUIL_MAJOR_VERSION = '0'

# Mandatory waf variables
APPNAME = 'suil'        # Package name for waf dist
VERSION = SUIL_VERSION  # Package version for waf dist
top     = '.'           # Source directory
out     = 'build'       # Build directory

def options(opt):
    opt.load('compiler_c')
    opt.load('compiler_cxx')
    autowaf.set_options(opt)
    opt.add_option('--static', action='store_true', dest='static',
                   help="Build static library")
    opt.add_option('--no-shared', action='store_true', dest='no_shared',
                   help='Do not build shared library')
    opt.add_option('--no-gtk', action='store_true', dest='no_gtk',
                   help='Do not build support for Gtk')
    opt.add_option('--no-qt', action='store_true', dest='no_qt',
                   help='Do not build support for Qt (any version)')
    opt.add_option('--no-qt4', action='store_true', dest='no_qt4',
                   help='Do not build support for Qt4')
    opt.add_option('--no-qt5', action='store_true', dest='no_qt5',
                   help='Do not build support for Qt5')
    opt.add_option('--gtk2-lib-name', type='string', dest='gtk2_lib_name',
                   default="libgtk-x11-2.0.so.0",
                   help="Gtk2 library name [Default: libgtk-x11-2.0.so.0]")

def configure(conf):
    conf.line_just = 40
    conf.load('compiler_c')
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.set_c99_mode(conf)
    autowaf.display_header('Suil Configuration')

    conf.env.BUILD_SHARED = not Options.options.no_shared
    conf.env.BUILD_STATIC = Options.options.static

    if not conf.env.BUILD_SHARED and not conf.env.BUILD_STATIC:
        conf.fatal('Neither a shared nor a static build requested')

    conf.env.NODELETE_FLAGS = []
    if (not conf.env.MSVC_COMPILER and
        conf.check(linkflags = ['-Wl,-z,nodelete'],
                   msg       = 'Checking for link flags -Wl,-z,-nodelete',
                   mandatory = False)):
        conf.env.NODELETE_FLAGS = ['-Wl,-z,nodelete']

    autowaf.check_pkg(conf, 'lv2', atleast_version='1.12.0', uselib_store='LV2')

    if not Options.options.no_gtk:
        autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK2',
                          atleast_version='2.18.0', mandatory=False)
        if not conf.env.HAVE_GTK2:
            autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK2',
                              atleast_version='2.0.0', mandatory=False)
            if conf.env.HAVE_GTK2:
                autowaf.define(conf, 'SUIL_OLD_GTK', 1)

        autowaf.check_pkg(conf, 'gtk+-x11-2.0', uselib_store='GTK2_X11',
                          atleast_version='2.0.0', mandatory=False)

        autowaf.check_pkg(conf, 'gtk+-quartz-2.0', uselib_store='GTK2_QUARTZ',
                          atleast_version='2.0.0', mandatory=False)

    if not Options.options.no_qt:
        if not Options.options.no_qt4:
            autowaf.check_pkg(conf, 'QtGui', uselib_store='QT4',
                              atleast_version='4.4.0', mandatory=False)

        if not Options.options.no_qt5:
            autowaf.check_pkg(conf, 'Qt5Widgets', uselib_store='QT5',
                              atleast_version='5.1.0', mandatory=False)

    conf.check_cc(define_name   = 'HAVE_LIBDL',
                  lib           = 'dl',
                  mandatory     = False)

    autowaf.define(conf, 'SUIL_VERSION', SUIL_VERSION)
    autowaf.define(conf, 'SUIL_MODULE_DIR',
                   conf.env.LIBDIR + '/suil-' + SUIL_MAJOR_VERSION)
    autowaf.define(conf, 'SUIL_DIR_SEP', '/')
    autowaf.define(conf, 'SUIL_GTK2_LIB_NAME', Options.options.gtk2_lib_name);

    if conf.env.HAVE_GTK2 and conf.env.HAVE_QT4:
        autowaf.define(conf, 'SUIL_WITH_GTK2_IN_QT4', 1)
        autowaf.define(conf, 'SUIL_WITH_QT4_IN_GTK2', 1)

    if conf.env.HAVE_GTK2 and conf.env.HAVE_QT5:
        autowaf.define(conf, 'SUIL_WITH_GTK2_IN_QT5', 1)

    if conf.env.HAVE_GTK2 and conf.env.HAVE_GTK2_X11:
        autowaf.define(conf, 'SUIL_WITH_X11_IN_GTK2', 1)

    if conf.env.HAVE_GTK2 and conf.env.HAVE_GTK2_QUARTZ:
        autowaf.define(conf, 'SUIL_WITH_COCOA_IN_GTK2', 1)

    if conf.env.HAVE_GTK2 and conf.env.DEST_OS == 'win32':
        autowaf.define(conf, 'SUIL_WITH_WIN_IN_GTK2', 1)

    if conf.env.HAVE_QT4:
        autowaf.define(conf, 'SUIL_WITH_X11_IN_QT4', 1)

    if conf.env.HAVE_QT5:
        autowaf.define(conf, 'SUIL_WITH_X11_IN_QT5', 1)

    module_prefix = ''
    module_ext    = ''
    if conf.env.PARDEBUG:
        module_ext += 'D'
    if conf.env.DEST_OS == 'win32':
        module_ext += '.dll'
    elif conf.env.DEST_OS == 'darwin':
        module_prefix = 'lib'
        module_ext += '.dylib'
    else:
        module_prefix = 'lib'
        module_ext += '.so'

    autowaf.define(conf, 'SUIL_MODULE_PREFIX', module_prefix)
    autowaf.define(conf, 'SUIL_MODULE_EXT', module_ext)

    autowaf.set_lib_env(conf, 'suil', SUIL_VERSION)
    conf.write_config_header('suil_config.h', remove=False)

    autowaf.display_msg(conf, "Gtk2 Support", bool(conf.env.HAVE_GTK2))
    if conf.env.HAVE_GTK2:
        autowaf.display_msg(conf, "Gtk2 Library Name",
                            conf.env.SUIL_GTK2_LIB_NAME)
    autowaf.display_msg(conf, "Qt4 Support", bool(conf.env.HAVE_QT4))
    autowaf.display_msg(conf, "Qt5 Support", bool(conf.env.HAVE_QT5))
    print('')

def build(bld):
    # C Headers
    includedir = '${INCLUDEDIR}/suil-%s/suil' % SUIL_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('suil/*.h'))
    TaskGen.task_gen.mappings['.mm'] = TaskGen.task_gen.mappings['.cc']

    # Pkgconfig file
    autowaf.build_pc(bld, 'SUIL', SUIL_VERSION, SUIL_MAJOR_VERSION, [],
                     {'SUIL_MAJOR_VERSION' : SUIL_MAJOR_VERSION})

    cflags = []
    lib    = []
    modlib = []
    if bld.env.DEST_OS == 'win32':
        modlib += ['user32']
    else:
        cflags += ['-fvisibility=hidden']
        if bld.is_defined('HAVE_LIBDL'):
            lib    += ['dl']
            modlib += ['dl']

    module_dir = '${LIBDIR}/suil-' + SUIL_MAJOR_VERSION

    # Shared Library
    if bld.env.BUILD_SHARED:
        obj = bld(features        = 'c cshlib',
                  export_includes = ['.'],
                  source          = 'src/host.c src/instance.c',
                  target          = 'suil-%s' % SUIL_MAJOR_VERSION,
                  includes        = ['.'],
                  defines         = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  name            = 'libsuil',
                  vnum            = SUIL_VERSION,
                  install_path    = '${LIBDIR}',
                  cflags          = cflags,
                  lib             = lib,
                  uselib          = 'LV2')

    # Static library
    if bld.env.BUILD_STATIC:
        obj = bld(features        = 'c cstlib',
                  export_includes = ['.'],
                  source          = 'src/host.c src/instance.c',
                  target          = 'suil-%s' % SUIL_MAJOR_VERSION,
                  includes        = ['.'],
                  defines         = ['SUIL_INTERNAL'],
                  name            = 'libsuil_static',
                  vnum            = SUIL_VERSION,
                  install_path    = '${LIBDIR}',
                  cflags          = cflags,
                  lib             = lib,
                  uselib          = 'LV2')

    if bld.env.SUIL_WITH_GTK2_IN_QT4:
        obj = bld(features     = 'cxx cxxshlib',
                  source       = 'src/gtk2_in_qt4.cpp',
                  target       = 'suil_gtk2_in_qt4',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib)
        autowaf.use_lib(bld, obj, 'GTK2 QT4 LV2')

    if bld.env.SUIL_WITH_GTK2_IN_QT5:
        obj = bld(features     = 'cxx cxxshlib',
                  source       = 'src/gtk2_in_qt5.cpp',
                  target       = 'suil_gtk2_in_qt5',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib)
        autowaf.use_lib(bld, obj, 'GTK2 QT5 LV2')

    if bld.env.SUIL_WITH_QT4_IN_GTK2:
        obj = bld(features     = 'cxx cxxshlib',
                  source       = 'src/qt4_in_gtk2.cpp',
                  target       = 'suil_qt4_in_gtk2',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib,
                  linkflags    = bld.env.NODELETE_FLAGS)
        autowaf.use_lib(bld, obj, 'GTK2 QT4 LV2')

    if bld.env.SUIL_WITH_X11_IN_GTK2:
        obj = bld(features     = 'c cshlib',
                  source       = 'src/x11_in_gtk2.c',
                  target       = 'suil_x11_in_gtk2',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib + ['X11'],
                  linkflags    = bld.env.NODELETE_FLAGS)
        autowaf.use_lib(bld, obj, 'GTK2 GTK2_X11 LV2')

    if bld.env.SUIL_WITH_COCOA_IN_GTK2:
        obj = bld(features     = 'cxx cshlib',
                  source       = 'src/cocoa_in_gtk2.mm',
                  target       = 'suil_cocoa_in_gtk2',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib,
                  linkflags    = ['-framework', 'Cocoa'])
        autowaf.use_lib(bld, obj, 'GTK2 LV2')

    if bld.env.SUIL_WITH_WIN_IN_GTK2:
        obj = bld(features     = 'cxx cxxshlib',
                  source       = 'src/win_in_gtk2.cpp',
                  target       = 'suil_win_in_gtk2',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib,
                  linkflags    = bld.env.NODELETE_FLAGS)
        autowaf.use_lib(bld, obj, 'GTK2 LV2')

    if bld.env.SUIL_WITH_X11_IN_QT4:
        obj = bld(features     = 'cxx cxxshlib',
                  source       = 'src/x11_in_qt4.cpp',
                  target       = 'suil_x11_in_qt4',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib)
        autowaf.use_lib(bld, obj, 'QT4 LV2')

    if bld.env.SUIL_WITH_X11_IN_QT5:
        obj = bld(features     = 'cxx cxxshlib',
                  source       = 'src/x11_in_qt5.cpp',
                  target       = 'suil_x11_in_qt5',
                  includes     = ['.'],
                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                  install_path = module_dir,
                  cflags       = cflags,
                  lib          = modlib)
        autowaf.use_lib(bld, obj, 'QT5 LV2')

    # Documentation
    autowaf.build_dox(bld, 'SUIL', SUIL_VERSION, top, out)

    bld.add_post_fun(autowaf.run_ldconfig)
