=== debian/changelog ===
suil (0.8.4~dfsg0-2) unstable; urgency=medium

  * Add patch to fix FTBFS with Qt 5.7. (Closes: #844101)
  * Set dh/compat 10.
  * Set dh/compat 10.
  * Drop dbg package in favour of dbgsym.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 12 Nov 2016 17:27:52 +0100

suil (0.8.4~dfsg0-1) unstable; urgency=medium

  * Fix watch file.
  * Fix repacking.
  * New upstream version 0.8.4~dfsg0
  * Bump Standards.
  * Fix VCS fields.
  * Fix hardening.
  * Add B-D for Qt5 support.
  * Tighten B-D for lv2-dev.
  * Update copyright file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 22 Sep 2016 21:22:24 +0200
