## suil 0.10.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -1,17 +1,12 @@
 #!/usr/bin/env python
 import os
 import subprocess
-import sys
-import waflib.Options as Options
+import waflib.TaskGen as TaskGen
 import waflib.extras.autowaf as autowaf
-from waflib import TaskGen
-
-# Library and package version (UNIX style major, minor, micro)
-# major increment <=> incompatible changes
-# minor increment <=> compatible changes (additions)
-# micro increment <=> no interface changes
-SUIL_VERSION       = '0.8.4'
-SUIL_MAJOR_VERSION = '0'
+
+# Semver package/library version
+SUIL_VERSION       = '0.10.0'
+SUIL_MAJOR_VERSION = SUIL_VERSION[0:SUIL_VERSION.find('.')]
 
 # Mandatory waf variables
 APPNAME = 'suil'        # Package name for waf dist
@@ -19,36 +14,41 @@
 top     = '.'           # Source directory
 out     = 'build'       # Build directory
 
-def options(opt):
-    opt.load('compiler_c')
-    opt.load('compiler_cxx')
-    autowaf.set_options(opt)
+def options(ctx):
+    ctx.load('compiler_c')
+    ctx.load('compiler_cxx')
+    autowaf.set_options(ctx)
+    opt = ctx.get_option_group('Configuration options')
     opt.add_option('--static', action='store_true', dest='static',
-                   help="Build static library")
+                   help='build static library')
     opt.add_option('--no-shared', action='store_true', dest='no_shared',
-                   help='Do not build shared library')
+                   help='do not build shared library')
     opt.add_option('--no-gtk', action='store_true', dest='no_gtk',
-                   help='Do not build support for Gtk')
+                   help='do not build support for Gtk')
     opt.add_option('--no-qt', action='store_true', dest='no_qt',
-                   help='Do not build support for Qt (any version)')
+                   help='do not build support for Qt (any version)')
     opt.add_option('--no-qt4', action='store_true', dest='no_qt4',
-                   help='Do not build support for Qt4')
+                   help='do not build support for Qt4')
     opt.add_option('--no-qt5', action='store_true', dest='no_qt5',
-                   help='Do not build support for Qt5')
+                   help='do not build support for Qt5')
     opt.add_option('--gtk2-lib-name', type='string', dest='gtk2_lib_name',
                    default="libgtk-x11-2.0.so.0",
                    help="Gtk2 library name [Default: libgtk-x11-2.0.so.0]")
+    opt.add_option('--gtk3-lib-name', type='string', dest='gtk3_lib_name',
+                   default="libgtk-x11-3.0.so.0",
+                   help="Gtk3 library name [Default: libgtk-x11-3.0.so.0]")
 
 def configure(conf):
     conf.line_just = 40
     conf.load('compiler_c')
     conf.load('compiler_cxx')
     autowaf.configure(conf)
+    autowaf.display_header('Suil Configuration')
     autowaf.set_c99_mode(conf)
-    autowaf.display_header('Suil Configuration')
-
-    conf.env.BUILD_SHARED = not Options.options.no_shared
-    conf.env.BUILD_STATIC = Options.options.static
+    autowaf.set_cxx11_mode(conf)
+
+    conf.env.BUILD_SHARED = not conf.options.no_shared
+    conf.env.BUILD_STATIC = conf.options.static
 
     if not conf.env.BUILD_SHARED and not conf.env.BUILD_STATIC:
         conf.fatal('Neither a shared nor a static build requested')
@@ -61,8 +61,9 @@
         conf.env.NODELETE_FLAGS = ['-Wl,-z,nodelete']
 
     autowaf.check_pkg(conf, 'lv2', atleast_version='1.12.0', uselib_store='LV2')
-
-    if not Options.options.no_gtk:
+    autowaf.check_pkg(conf, 'x11', uselib_store='X11', mandatory=False)
+
+    if not conf.options.no_gtk:
         autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK2',
                           atleast_version='2.18.0', mandatory=False)
         if not conf.env.HAVE_GTK2:
@@ -77,12 +78,18 @@
         autowaf.check_pkg(conf, 'gtk+-quartz-2.0', uselib_store='GTK2_QUARTZ',
                           atleast_version='2.0.0', mandatory=False)
 
-    if not Options.options.no_qt:
-        if not Options.options.no_qt4:
+        autowaf.check_pkg(conf, 'gtk+-3.0', uselib_store='GTK3',
+                          atleast_version='3.14.0', mandatory=False)
+
+        autowaf.check_pkg(conf, 'gtk+-x11-3.0', uselib_store='GTK3_X11',
+                          atleast_version='3.14.0', mandatory=False)
+
+    if not conf.options.no_qt:
+        if not conf.options.no_qt4:
             autowaf.check_pkg(conf, 'QtGui', uselib_store='QT4',
                               atleast_version='4.4.0', mandatory=False)
 
-        if not Options.options.no_qt5:
+        if not conf.options.no_qt5:
             autowaf.check_pkg(conf, 'Qt5Widgets', uselib_store='QT5',
                               atleast_version='5.1.0', mandatory=False)
 
@@ -94,7 +101,8 @@
     autowaf.define(conf, 'SUIL_MODULE_DIR',
                    conf.env.LIBDIR + '/suil-' + SUIL_MAJOR_VERSION)
     autowaf.define(conf, 'SUIL_DIR_SEP', '/')
-    autowaf.define(conf, 'SUIL_GTK2_LIB_NAME', Options.options.gtk2_lib_name);
+    autowaf.define(conf, 'SUIL_GTK2_LIB_NAME', conf.options.gtk2_lib_name);
+    autowaf.define(conf, 'SUIL_GTK3_LIB_NAME', conf.options.gtk3_lib_name);
 
     if conf.env.HAVE_GTK2 and conf.env.HAVE_QT4:
         autowaf.define(conf, 'SUIL_WITH_GTK2_IN_QT4', 1)
@@ -102,10 +110,14 @@
 
     if conf.env.HAVE_GTK2 and conf.env.HAVE_QT5:
         autowaf.define(conf, 'SUIL_WITH_GTK2_IN_QT5', 1)
+        autowaf.define(conf, 'SUIL_WITH_QT5_IN_GTK2', 1)
 
     if conf.env.HAVE_GTK2 and conf.env.HAVE_GTK2_X11:
         autowaf.define(conf, 'SUIL_WITH_X11_IN_GTK2', 1)
 
+    if conf.env.HAVE_GTK3 and conf.env.HAVE_GTK3_X11:
+        autowaf.define(conf, 'SUIL_WITH_X11_IN_GTK3', 1)
+
     if conf.env.HAVE_GTK2 and conf.env.HAVE_GTK2_QUARTZ:
         autowaf.define(conf, 'SUIL_WITH_COCOA_IN_GTK2', 1)
 
@@ -117,6 +129,10 @@
 
     if conf.env.HAVE_QT5:
         autowaf.define(conf, 'SUIL_WITH_X11_IN_QT5', 1)
+        autowaf.set_cxx11_mode(conf)
+
+    if conf.env.HAVE_X11:
+        autowaf.define(conf, 'SUIL_WITH_X11', 1)
 
     module_prefix = ''
     module_ext    = ''
@@ -137,12 +153,29 @@
     autowaf.set_lib_env(conf, 'suil', SUIL_VERSION)
     conf.write_config_header('suil_config.h', remove=False)
 
-    autowaf.display_msg(conf, "Gtk2 Support", bool(conf.env.HAVE_GTK2))
     if conf.env.HAVE_GTK2:
         autowaf.display_msg(conf, "Gtk2 Library Name",
                             conf.env.SUIL_GTK2_LIB_NAME)
-    autowaf.display_msg(conf, "Qt4 Support", bool(conf.env.HAVE_QT4))
-    autowaf.display_msg(conf, "Qt5 Support", bool(conf.env.HAVE_QT5))
+    if conf.env.HAVE_GTK3:
+        autowaf.display_msg(conf, "Gtk3 Library Name",
+                            conf.env.SUIL_GTK3_LIB_NAME)
+
+    # Print summary message for every potentially supported wrapper
+    wrappers = [('cocoa', 'gtk2'),
+                ('gtk2', 'qt4'),
+                ('gtk2', 'qt5'),
+                ('qt4', 'gtk2'),
+                ('qt5', 'gtk2'),
+                ('win', 'gtk2'),
+                ('x11', 'gtk2'),
+                ('x11', 'gtk3'),
+                ('x11', 'qt4'),
+                ('x11', 'qt5')]
+    for w in wrappers:
+        var = 'SUIL_WITH_%s_IN_%s' % (w[0].upper(), w[1].upper())
+        autowaf.display_msg(conf, 'Support for %s in %s' % (w[0], w[1]),
+                            bool(conf.env[var]))
+
     print('')
 
 def build(bld):
@@ -205,7 +238,7 @@
                   includes     = ['.'],
                   defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                   install_path = module_dir,
-                  cflags       = cflags,
+                  cxxflags     = cflags,
                   lib          = modlib)
         autowaf.use_lib(bld, obj, 'GTK2 QT4 LV2')
 
@@ -216,7 +249,7 @@
                   includes     = ['.'],
                   defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                   install_path = module_dir,
-                  cflags       = cflags,
+                  cxxflags     = cflags,
                   lib          = modlib)
         autowaf.use_lib(bld, obj, 'GTK2 QT5 LV2')
 
@@ -227,10 +260,22 @@
                   includes     = ['.'],
                   defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
                   install_path = module_dir,
-                  cflags       = cflags,
+                  cxxflags     = cflags,
                   lib          = modlib,
                   linkflags    = bld.env.NODELETE_FLAGS)
         autowaf.use_lib(bld, obj, 'GTK2 QT4 LV2')
+
+    if bld.env.SUIL_WITH_QT5_IN_GTK2:
+        obj = bld(features     = 'cxx cxxshlib',
+                  source       = 'src/qt5_in_gtk2.cpp',
+                  target       = 'suil_qt5_in_gtk2',
+                  includes     = ['.'],
+                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
+                  install_path = module_dir,
+                  cxxflags     = cflags,
+                  lib          = modlib,
+                  linkflags    = bld.env.NODELETE_FLAGS)
+        autowaf.use_lib(bld, obj, 'GTK2 QT5 LV2')
 
     if bld.env.SUIL_WITH_X11_IN_GTK2:
         obj = bld(features     = 'c cshlib',
@@ -244,53 +289,8 @@
                   linkflags    = bld.env.NODELETE_FLAGS)
         autowaf.use_lib(bld, obj, 'GTK2 GTK2_X11 LV2')
 
-    if bld.env.SUIL_WITH_COCOA_IN_GTK2:
-        obj = bld(features     = 'cxx cshlib',
-                  source       = 'src/cocoa_in_gtk2.mm',
-                  target       = 'suil_cocoa_in_gtk2',
-                  includes     = ['.'],
-                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
-                  install_path = module_dir,
-                  cflags       = cflags,
-                  lib          = modlib,
-                  linkflags    = ['-framework', 'Cocoa'])
-        autowaf.use_lib(bld, obj, 'GTK2 LV2')
-
-    if bld.env.SUIL_WITH_WIN_IN_GTK2:
-        obj = bld(features     = 'cxx cxxshlib',
-                  source       = 'src/win_in_gtk2.cpp',
-                  target       = 'suil_win_in_gtk2',
-                  includes     = ['.'],
-                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
-                  install_path = module_dir,
-                  cflags       = cflags,
-                  lib          = modlib,
-                  linkflags    = bld.env.NODELETE_FLAGS)
-        autowaf.use_lib(bld, obj, 'GTK2 LV2')
-
-    if bld.env.SUIL_WITH_X11_IN_QT4:
-        obj = bld(features     = 'cxx cxxshlib',
-                  source       = 'src/x11_in_qt4.cpp',
-                  target       = 'suil_x11_in_qt4',
-                  includes     = ['.'],
-                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
-                  install_path = module_dir,
-                  cflags       = cflags,
-                  lib          = modlib)
-        autowaf.use_lib(bld, obj, 'QT4 LV2')
-
-    if bld.env.SUIL_WITH_X11_IN_QT5:
-        obj = bld(features     = 'cxx cxxshlib',
-                  source       = 'src/x11_in_qt5.cpp',
-                  target       = 'suil_x11_in_qt5',
-                  includes     = ['.'],
-                  defines      = ['SUIL_SHARED', 'SUIL_INTERNAL'],
-                  install_path = module_dir,
-                  cflags       = cflags,
-                  lib          = modlib)
-        autowaf.use_lib(bld, obj, 'QT5 LV2')
-
-    # Documentation
-    autowaf.build_dox(bld, 'SUIL', SUIL_VERSION, top, out)
-
-    bld.add_post_fun(autowaf.run_ldconfig)
+    if bld.env.SUIL_WITH_X11_IN_GTK3:
+        obj = bld(features     = 'c cshlib',
+                  source       = 'src/x11_in_gtk3.c',
+                  target       = 'suil_x11_in_gtk3',
+                  includes     = ['.'],
