=== debian/changelog ===
suil (0.10.0~dfsg0-1) unstable; urgency=medium

  [ Mateusz Łukasik ]
  * Team upload.
  * Drop Qt4 support. (Closes: #875205)

  [ Jaromír Mikeš ]
  * New upstream version 0.10.0~dfsg0
  * Patch refreshed.
  * Introduce postclone.sh script to ignore .pc/ dir.
  * Bump Standards.
  * Update copyright.
  * Sign tags.
  * Update symbols file .
  * Avoid useless linking.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 04 Oct 2017 20:51:34 +0200
