=== debian/control ===
--- 
+++ 
@@ -8,13 +8,12 @@
 Build-Depends:
  debhelper (>= 10),
  libgtk2.0-dev,
- libqt4-dev,
  qtbase5-dev,
  qttools5-dev-tools,
  lv2-dev (>= 1.12.0~),
  pkg-config,
  python
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Homepage: http://drobilla.net/software/suil/
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/suil.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/suil.git
@@ -37,7 +36,7 @@
  is designed such that hosts do not need to explicitly support
  particular toolkits whatsoever - if Suil supports a particular
  toolkit, then all hosts that use Suil will support that toolkit
- "for free". Suil currently supports GTK-2+ and Qt4
+ "for free". Suil currently supports GTK-2+ and QT5
  .
  This package provides the development files for suil.
 
@@ -57,6 +56,6 @@
  is designed such that hosts do not need to explicitly support
  particular toolkits whatsoever - if Suil supports a particular
  toolkit, then all hosts that use Suil will support that toolkit
- "for free". Suil currently supports GTK-2+ and Qt4
+ "for free". Suil currently supports GTK-2+ and QT5
  .
  This package provides the shared library.
