=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,10 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-LDFLAGS+=-Wl,--as-needed
+
 WAF = ./waf
 
 %:
