## suil 0.10.4

=== debian/changelog ===
suil (0.10.4-2) unstable; urgency=medium

  * Team upload
  * debian/: Only recommend dependencies of modules. The host application will
    already depend on the right UI toolkit anyway. (Closes: #875655)
  * debian/control: Remove obsolete Pre-Depends

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 16 Oct 2019 23:19:17 +0200

suil (0.10.4-1) unstable; urgency=medium

  * Team upload

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/control:
    - Set RRR: no
    - Bump debhelper compat to 12
    - Bump Standards-Version
    - B-D on libgtk-3-dev
  * debian/copyright: Document waflib
  * debian/: Use Python 3 to run waf

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 16 Oct 2019 00:47:22 +0200
