=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: suil
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 12),
  libgtk2.0-dev,
+ libgtk-3-dev,
  qtbase5-dev,
  qttools5-dev-tools,
- lv2-dev (>= 1.12.0~),
+ lv2-dev (>= 1.16),
  pkg-config,
- python
-Standards-Version: 4.1.0
+ python3
+Standards-Version: 4.4.1
 Homepage: http://drobilla.net/software/suil/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/suil.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/suil.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/suil.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/suil
+Rules-Requires-Root: no
 
 Package: libsuil-dev
 Section: libdevel
@@ -42,10 +44,11 @@
 
 Package: libsuil-0-0
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends:
+ ${shlibs:Recommends}
 Multi-Arch: same
 Description: library for loading and wrapping LV2 plugin UIs
  Suil makes it possible to load a UI of any toolkit in a host using
