=== debian/watch ===
version=4
http://download.drobilla.net/suil-(.*)\.tar\.bz2
