=== debian/changelog ===
suil (0.10.6-1) unstable; urgency=medium

  * Team upload

  [ Debian Janitor ]
  * Use secure URI in debian/watch

  [ Olivier Humbert ]
  * Use https protocol in d/control and d/copyright

  [ Dennis Braun ]
  * New upstream release
  * d/control: Bump standards version to 4.5.0
  * d/copyright: Update year
  * Remove d/unpack_waf.sh
  * d/rules: Fix FTCBFS

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 01 Feb 2020 18:48:43 +0100
