=== debian/control ===
--- 
+++ 
@@ -14,8 +14,8 @@
  lv2-dev (>= 1.16),
  pkg-config,
  python3
-Standards-Version: 4.4.1
-Homepage: http://drobilla.net/software/suil/
+Standards-Version: 4.5.0
+Homepage: https://drobilla.net/software/suil/
 Vcs-Git: https://salsa.debian.org/multimedia-team/suil.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/suil
 Rules-Requires-Root: no
