=== debian/watch ===
version=4
https://download.drobilla.net/suil-(.*)\.tar\.bz2
