## suil 0.10.8

=== debian/changelog ===
suil (0.10.8-1) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * Fix compression

  [ Dennis Braun ]
  * New upstream version 0.10.8
  * Add libqt5x11extras5-dev to B-Ds and sort B-Ds
  * Add Build-Depends-Package to symbols file
  * Add d/upstream/signing-key.asc
  * Add d/upstream/metadata
  * Add me as uploader
  * Bump dh-compat to 13
  * Update d/copyright year

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 07 Oct 2020 11:53:31 +0200
