=== debian/control ===
--- 
+++ 
@@ -4,14 +4,16 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
- Jaromír Mikeš <mira.mikes@seznam.cz>
+ Jaromír Mikeš <mira.mikes@seznam.cz>,
+ Dennis Braun <d_braun@kabelmail.de>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libgtk2.0-dev,
  libgtk-3-dev,
+ libqt5x11extras5-dev,
+ lv2-dev (>= 1.16),
  qtbase5-dev,
  qttools5-dev-tools,
- lv2-dev (>= 1.16),
  pkg-config,
  python3
 Standards-Version: 4.5.0
